export class Server {
    constructor(config) {
        this.server = NSCServer.alloc().init(config.logger ?? false, config.path, config.directory, config.index ?? null, config.hostName ?? '127.0.0.1', config.port ?? 8080, config.workers ?? 2, config.showFiles ?? false);
    }
    get status() {
        return this.server.status;
    }
    start() {
        return new Promise((resolve, reject) => {
            this.server.start((error) => {
                if (error) {
                    reject(error);
                }
                else {
                    resolve();
                }
            });
        });
    }
    stop(wait = false) {
        return new Promise((resolve, reject) => {
            this.server.stop(wait, (error) => {
                if (error) {
                    reject(error);
                }
                else {
                    resolve();
                }
            });
        });
    }
}
//# sourceMappingURL=index.ios.js.map