#ifndef WEBSERVER_C_H
#define WEBSERVER_C_H

/* Warning, this file is autogenerated by cbindgen. Don't modify this manually. */

#include <stdarg.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>

typedef enum CServerStatus {
  CServerStatus_Inactive,
  CServerStatus_Active,
  CServerStatus_Crashed,
  CServerStatus_Starting,
  CServerStatus_Stopping,
} CServerStatus;

typedef struct CServer CServer;

typedef struct CStaticServiceOptions {
  bool logger;
  const char *path;
  const char *directory;
  const char *index;
  const char *host_name;
  int16_t port;
  uint32_t workers;
  bool show_files;
} CStaticServiceOptions;

struct CServer *webserver_init(const struct CStaticServiceOptions *options);

void webserver_release(struct CServer *server);

void webserver_start(struct CServer *server, void *data, void (*callback)(char*, void*));

void webserver_stop(struct CServer *server, bool wait, void *data, void (*callback)(char*, void*));

enum CServerStatus webserver_status(struct CServer *server);

void webserver_error_release(char *error);

void webserver_set_status_callback(struct CServer *server,
                                   void *data,
                                   void (*callback)(enum CServerStatus, void*));

void webserver_clear_status_callback(struct CServer *server);

#endif /* WEBSERVER_C_H */
